package datacenter

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	logs "cloud.o-forge.io/core/oc-lib/logs"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type DatacenterMongoAccessor struct {
	utils.AbstractAccessor
}

func (dma *DatacenterMongoAccessor) DeleteOne(id string) (utils.DBObject, error) {
	return dma.GenericDeleteOne(id, dma)
}

func (dma *DatacenterMongoAccessor) UpdateOne(set map[string]interface{}, id string) (utils.DBObject, error) {
	return dma.GenericUpdateOne(set, id, dma)
}

func (dma *DatacenterMongoAccessor) StoreOne(data utils.DBObject) (utils.DBObject, error) {
	id, err := mongo.MONGOService.StoreOne(data.(*Datacenter), "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not store " + data.GetName() + " to db. Error: " + err.Error())
		return nil, err
	}
	return dma.LoadOne(id)
}

func (dca *DatacenterMongoAccessor) LoadOne(id string) (utils.DBObject, error) {
	var datacenter Datacenter

	res_mongo, err := mongo.MONGOService.LoadOne(id, "datacenter")
	if err != nil {
		l := logs.CreateLogger("oclib", "")
		l.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return nil, err
	}

	res_mongo.Decode(&datacenter)

	return &datacenter, nil
}
