package processing

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/logs"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type ProcessingMongoAccessor struct {
	utils.AbstractAccessor
}

func (dma *ProcessingMongoAccessor) DeleteOne(id string) (utils.DBObject, error) {
	return dma.GenericDeleteOne(id, dma)
}

func (dma *ProcessingMongoAccessor) UpdateOne(set map[string]interface{}, id string) (utils.DBObject, error) {
	return dma.GenericUpdateOne(set, id, dma)
}

func (dma *ProcessingMongoAccessor) StoreOne(data utils.DBObject) (utils.DBObject, error) {
	id, err := mongo.MONGOService.StoreOne(data.(*Processing), "data")
	if err != nil {
		dma.Logger.Error().Msg("Could not store " + data.GetName() + " to db. Error: " + err.Error())
		return nil, err
	}
	return dma.LoadOne(id)
}

func (pma *ProcessingMongoAccessor) LoadOne(id string) (utils.DBObject, error) {

	var processing Processing

	res_mongo, err := mongo.MONGOService.LoadOne(id, "processing")
	if err != nil {
		l := logs.CreateLogger("oclib", "")
		l.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return nil, err
	}

	res_mongo.Decode(&processing)

	return &processing, nil
}
