package storage

import (
	"testing"

	resources "cloud.o-forge.io/core/oc-lib/models/resources"

	"github.com/stretchr/testify/assert"
)

func TestStoreOneStorage(t *testing.T) {
	s := Storage{Capacity: 123, Url: URL{Protocol: "http", Path: "azerty.fr"},
		AbstractResource: resources.AbstractResource{
			Uuid:        "123",
			Name:        "testData",
			Description: "Lorem Ipsum",
			Logo:        "azerty.com",
			Owner:       "toto",
			OwnerLogo:   "totoLogo",
			SourceUrl:   "azerty.fr",
		},
	}

	sma := StorageMongoAccessor{}
	id, _ := sma.StoreOne(&s)

	assert.NotEmpty(t, id)
}

func TestLoadOneStorage(t *testing.T) {
	s := Storage{Capacity: 123, Url: URL{Protocol: "http", Path: "azerty.fr"},
		AbstractResource: resources.AbstractResource{
			Uuid:        "123",
			Name:        "testData",
			Description: "Lorem Ipsum",
			Logo:        "azerty.com",
			Owner:       "toto",
			OwnerLogo:   "totoLogo",
			SourceUrl:   "azerty.fr",
		},
	}

	sma := StorageMongoAccessor{}
	new_s, _ := sma.StoreOne(&s)

	assert.Equal(t, s, new_s)
}
