package utils

type DBObject interface {
	GetName() string
	Deserialize(j map[string]interface{}) DBObject
	GetAccessor() Accessor
}

type Accessor interface {
	SetLogger()
	LoadOne(id string) (DBObject, error)
	DeleteOne(id string) (DBObject, error)
	StoreOne(data DBObject) (DBObject, error)
	UpdateOne(set map[string]interface{}, id string) (DBObject, error)
}
